import expect from 'expect';
import domMap from '../../src/domMap';

describe('domMap API', function () {
  it('entries', function () {
    expect(domMap.entries()).toEqual(
      expect.arrayContaining(
        [
          ["a", {"reserved": false}],
          ["abbr", {"reserved": false}],
          ["acronym", {"reserved": false}],
          ["address", {"reserved": false}],
          ["applet", {"reserved": false}],
          ["area", {"reserved": false}],
          ["article", {"reserved": false}],
          ["aside", {"reserved": false}],
          ["audio", {"reserved": false}],
          ["b", {"reserved": false}],
          ["base", {"reserved": true}],
          ["bdi", {"reserved": false}],
          ["bdo", {"reserved": false}],
          ["big", {"reserved": false}],
          ["blink", {"reserved": false}],
          ["blockquote", {"reserved": false}],
          ["body", {"reserved": false}],
          ["br", {"reserved": false}],
          ["button", {"reserved": false}],
          ["canvas", {"reserved": false}],
          ["caption", {"reserved": false}],
          ["center", {"reserved": false}],
          ["cite", {"reserved": false}],
          ["code", {"reserved": false}],
          ["col", {"reserved": true}],
          ["colgroup", {"reserved": true}],
          ["content", {"reserved": false}],
          ["data", {"reserved": false}],
          ["datalist", {"reserved": false}],
          ["dd", {"reserved": false}],
          ["del", {"reserved": false}],
          ["details", {"reserved": false}],
          ["dfn", {"reserved": false}],
          ["dialog", {"reserved": false}],
          ["dir", {"reserved": false}],
          ["div", {"reserved": false}],
          ["dl", {"reserved": false}],
          ["dt", {"reserved": false}],
          ["em", {"reserved": false}],
          ["embed", {"reserved": false}],
          ["fieldset", {"reserved": false}],
          ["figcaption", {"reserved": false}],
          ["figure", {"reserved": false}],
          ["font", {"reserved": false}],
          ["footer", {"reserved": false}],
          ["form", {"reserved": false}],
          ["frame", {"reserved": false}],
          ["frameset", {"reserved": false}],
          ["h1", {"reserved": false}],
          ["h2", {"reserved": false}],
          ["h3", {"reserved": false}],
          ["h4", {"reserved": false}],
          ["h5", {"reserved": false}],
          ["h6", {"reserved": false}],
          ["head", {"reserved": true}],
          ["header", {"reserved": false}],
          ["hgroup", {"reserved": false}],
          ["hr", {"reserved": false}],
          ["html", {"reserved": true}],
          ["i", {"reserved": false}],
          ["iframe", {"reserved": false}],
          ["img", {"reserved": false}],
          ["input", {"reserved": false}],
          ["ins", {"reserved": false}],
          ["kbd", {"reserved": false}],
          ["keygen", {"reserved": false}],
          ["label", {"reserved": false}],
          ["legend", {"reserved": false}],
          ["li", {"reserved": false}],
          ["link", {"reserved": true}],
          ["main", {"reserved": false}],
          ["map", {"reserved": false}],
          ["mark", {"reserved": false}],
          ["marquee", {"reserved": false}],
          ["menu", {"reserved": false}],
          ["menuitem", {"reserved": false}],
          ["meta", {"reserved": true}],
          ["meter", {"reserved": false}],
          ["nav", {"reserved": false}],
          ["noembed", {"reserved": true}],
          ["noscript", {"reserved": true}],
          ["object", {"reserved": false}],
          ["ol", {"reserved": false}],
          ["optgroup", {"reserved": false}],
          ["option", {"reserved": false}],
          ["output", {"reserved": false}],
          ["p", {"reserved": false}],
          ["param", {"reserved": true}],
          ["picture", {"reserved": true}],
          ["pre", {"reserved": false}],
          ["progress", {"reserved": false}],
          ["q", {"reserved": false}],
          ["rp", {"reserved": false}],
          ["rt", {"reserved": false}],
          ["rtc", {"reserved": false}],
          ["ruby", {"reserved": false}],
          ["s", {"reserved": false}],
          ["samp", {"reserved": false}],
          ["script", {"reserved": true}],
          ["section", {"reserved": false}],
          ["select", {"reserved": false}],
          ["small", {"reserved": false}],
          ["source", {"reserved": true}],
          ["spacer", {"reserved": false}],
          ["span", {"reserved": false}],
          ["strike", {"reserved": false}],
          ["strong", {"reserved": false}],
          ["style", {"reserved": true}],
          ["sub", {"reserved": false}],
          ["summary", {"reserved": false}],
          ["sup", {"reserved": false}],
          ["table", {"reserved": false}],
          ["tbody", {"reserved": false}],
          ["td", {"reserved": false}],
          ["textarea", {"reserved": false}],
          ["tfoot", {"reserved": false}],
          ["th", {"reserved": false}],
          ["thead", {"reserved": false}],
          ["time", {"reserved": false}],
          ["title", {"reserved": true}],
          ["tr", {"reserved": false}],
          ["track", {"reserved": true}],
          ["tt", {"reserved": false}],
          ["u", {"reserved": false}],
          ["ul", {"reserved": false}],
          ["var", {"reserved": false}],
          ["video", {"reserved": false}],
          ["wbr", {"reserved": false}],
          ["xmp", {"reserved": false}],
        ],
      ),
    );
    expect([...domMap.entries()]).toEqual(
      expect.arrayContaining(
        [
          ["a", {"reserved": false}],
          ["abbr", {"reserved": false}],
          ["acronym", {"reserved": false}],
          ["address", {"reserved": false}],
          ["applet", {"reserved": false}],
          ["area", {"reserved": false}],
          ["article", {"reserved": false}],
          ["aside", {"reserved": false}],
          ["audio", {"reserved": false}],
          ["b", {"reserved": false}],
          ["base", {"reserved": true}],
          ["bdi", {"reserved": false}],
          ["bdo", {"reserved": false}],
          ["big", {"reserved": false}],
          ["blink", {"reserved": false}],
          ["blockquote", {"reserved": false}],
          ["body", {"reserved": false}],
          ["br", {"reserved": false}],
          ["button", {"reserved": false}],
          ["canvas", {"reserved": false}],
          ["caption", {"reserved": false}],
          ["center", {"reserved": false}],
          ["cite", {"reserved": false}],
          ["code", {"reserved": false}],
          ["col", {"reserved": true}],
          ["colgroup", {"reserved": true}],
          ["content", {"reserved": false}],
          ["data", {"reserved": false}],
          ["datalist", {"reserved": false}],
          ["dd", {"reserved": false}],
          ["del", {"reserved": false}],
          ["details", {"reserved": false}],
          ["dfn", {"reserved": false}],
          ["dialog", {"reserved": false}],
          ["dir", {"reserved": false}],
          ["div", {"reserved": false}],
          ["dl", {"reserved": false}],
          ["dt", {"reserved": false}],
          ["em", {"reserved": false}],
          ["embed", {"reserved": false}],
          ["fieldset", {"reserved": false}],
          ["figcaption", {"reserved": false}],
          ["figure", {"reserved": false}],
          ["font", {"reserved": false}],
          ["footer", {"reserved": false}],
          ["form", {"reserved": false}],
          ["frame", {"reserved": false}],
          ["frameset", {"reserved": false}],
          ["h1", {"reserved": false}],
          ["h2", {"reserved": false}],
          ["h3", {"reserved": false}],
          ["h4", {"reserved": false}],
          ["h5", {"reserved": false}],
          ["h6", {"reserved": false}],
          ["head", {"reserved": true}],
          ["header", {"reserved": false}],
          ["hgroup", {"reserved": false}],
          ["hr", {"reserved": false}],
          ["html", {"reserved": true}],
          ["i", {"reserved": false}],
          ["iframe", {"reserved": false}],
          ["img", {"reserved": false}],
          ["input", {"reserved": false}],
          ["ins", {"reserved": false}],
          ["kbd", {"reserved": false}],
          ["keygen", {"reserved": false}],
          ["label", {"reserved": false}],
          ["legend", {"reserved": false}],
          ["li", {"reserved": false}],
          ["link", {"reserved": true}],
          ["main", {"reserved": false}],
          ["map", {"reserved": false}],
          ["mark", {"reserved": false}],
          ["marquee", {"reserved": false}],
          ["menu", {"reserved": false}],
          ["menuitem", {"reserved": false}],
          ["meta", {"reserved": true}],
          ["meter", {"reserved": false}],
          ["nav", {"reserved": false}],
          ["noembed", {"reserved": true}],
          ["noscript", {"reserved": true}],
          ["object", {"reserved": false}],
          ["ol", {"reserved": false}],
          ["optgroup", {"reserved": false}],
          ["option", {"reserved": false}],
          ["output", {"reserved": false}],
          ["p", {"reserved": false}],
          ["param", {"reserved": true}],
          ["picture", {"reserved": true}],
          ["pre", {"reserved": false}],
          ["progress", {"reserved": false}],
          ["q", {"reserved": false}],
          ["rp", {"reserved": false}],
          ["rt", {"reserved": false}],
          ["rtc", {"reserved": false}],
          ["ruby", {"reserved": false}],
          ["s", {"reserved": false}],
          ["samp", {"reserved": false}],
          ["script", {"reserved": true}],
          ["section", {"reserved": false}],
          ["select", {"reserved": false}],
          ["small", {"reserved": false}],
          ["source", {"reserved": true}],
          ["spacer", {"reserved": false}],
          ["span", {"reserved": false}],
          ["strike", {"reserved": false}],
          ["strong", {"reserved": false}],
          ["style", {"reserved": true}],
          ["sub", {"reserved": false}],
          ["summary", {"reserved": false}],
          ["sup", {"reserved": false}],
          ["table", {"reserved": false}],
          ["tbody", {"reserved": false}],
          ["td", {"reserved": false}],
          ["textarea", {"reserved": false}],
          ["tfoot", {"reserved": false}],
          ["th", {"reserved": false}],
          ["thead", {"reserved": false}],
          ["time", {"reserved": false}],
          ["title", {"reserved": true}],
          ["tr", {"reserved": false}],
          ["track", {"reserved": true}],
          ["tt", {"reserved": false}],
          ["u", {"reserved": false}],
          ["ul", {"reserved": false}],
          ["var", {"reserved": false}],
          ["video", {"reserved": false}],
          ["wbr", {"reserved": false}],
          ["xmp", {"reserved": false}],
        ],
      ),
    );
  });
  it('forEach', function () {
    const output = [];
    let context;
    domMap.forEach((value, key, map) => {
      output.push([key, value]);
      if (!context) {
        context = map;
      }
    });
    expect(output).toEqual(
      expect.arrayContaining(
        [
          ["a", {"reserved": false}],
          ["abbr", {"reserved": false}],
          ["acronym", {"reserved": false}],
          ["address", {"reserved": false}],
          ["applet", {"reserved": false}],
          ["area", {"reserved": false}],
          ["article", {"reserved": false}],
          ["aside", {"reserved": false}],
          ["audio", {"reserved": false}],
          ["b", {"reserved": false}],
          ["base", {"reserved": true}],
          ["bdi", {"reserved": false}],
          ["bdo", {"reserved": false}],
          ["big", {"reserved": false}],
          ["blink", {"reserved": false}],
          ["blockquote", {"reserved": false}],
          ["body", {"reserved": false}],
          ["br", {"reserved": false}],
          ["button", {"reserved": false}],
          ["canvas", {"reserved": false}],
          ["caption", {"reserved": false}],
          ["center", {"reserved": false}],
          ["cite", {"reserved": false}],
          ["code", {"reserved": false}],
          ["col", {"reserved": true}],
          ["colgroup", {"reserved": true}],
          ["content", {"reserved": false}],
          ["data", {"reserved": false}],
          ["datalist", {"reserved": false}],
          ["dd", {"reserved": false}],
          ["del", {"reserved": false}],
          ["details", {"reserved": false}],
          ["dfn", {"reserved": false}],
          ["dialog", {"reserved": false}],
          ["dir", {"reserved": false}],
          ["div", {"reserved": false}],
          ["dl", {"reserved": false}],
          ["dt", {"reserved": false}],
          ["em", {"reserved": false}],
          ["embed", {"reserved": false}],
          ["fieldset", {"reserved": false}],
          ["figcaption", {"reserved": false}],
          ["figure", {"reserved": false}],
          ["font", {"reserved": false}],
          ["footer", {"reserved": false}],
          ["form", {"reserved": false}],
          ["frame", {"reserved": false}],
          ["frameset", {"reserved": false}],
          ["h1", {"reserved": false}],
          ["h2", {"reserved": false}],
          ["h3", {"reserved": false}],
          ["h4", {"reserved": false}],
          ["h5", {"reserved": false}],
          ["h6", {"reserved": false}],
          ["head", {"reserved": true}],
          ["header", {"reserved": false}],
          ["hgroup", {"reserved": false}],
          ["hr", {"reserved": false}],
          ["html", {"reserved": true}],
          ["i", {"reserved": false}],
          ["iframe", {"reserved": false}],
          ["img", {"reserved": false}],
          ["input", {"reserved": false}],
          ["ins", {"reserved": false}],
          ["kbd", {"reserved": false}],
          ["keygen", {"reserved": false}],
          ["label", {"reserved": false}],
          ["legend", {"reserved": false}],
          ["li", {"reserved": false}],
          ["link", {"reserved": true}],
          ["main", {"reserved": false}],
          ["map", {"reserved": false}],
          ["mark", {"reserved": false}],
          ["marquee", {"reserved": false}],
          ["menu", {"reserved": false}],
          ["menuitem", {"reserved": false}],
          ["meta", {"reserved": true}],
          ["meter", {"reserved": false}],
          ["nav", {"reserved": false}],
          ["noembed", {"reserved": true}],
          ["noscript", {"reserved": true}],
          ["object", {"reserved": false}],
          ["ol", {"reserved": false}],
          ["optgroup", {"reserved": false}],
          ["option", {"reserved": false}],
          ["output", {"reserved": false}],
          ["p", {"reserved": false}],
          ["param", {"reserved": true}],
          ["picture", {"reserved": true}],
          ["pre", {"reserved": false}],
          ["progress", {"reserved": false}],
          ["q", {"reserved": false}],
          ["rp", {"reserved": false}],
          ["rt", {"reserved": false}],
          ["rtc", {"reserved": false}],
          ["ruby", {"reserved": false}],
          ["s", {"reserved": false}],
          ["samp", {"reserved": false}],
          ["script", {"reserved": true}],
          ["section", {"reserved": false}],
          ["select", {"reserved": false}],
          ["small", {"reserved": false}],
          ["source", {"reserved": true}],
          ["spacer", {"reserved": false}],
          ["span", {"reserved": false}],
          ["strike", {"reserved": false}],
          ["strong", {"reserved": false}],
          ["style", {"reserved": true}],
          ["sub", {"reserved": false}],
          ["summary", {"reserved": false}],
          ["sup", {"reserved": false}],
          ["table", {"reserved": false}],
          ["tbody", {"reserved": false}],
          ["td", {"reserved": false}],
          ["textarea", {"reserved": false}],
          ["tfoot", {"reserved": false}],
          ["th", {"reserved": false}],
          ["thead", {"reserved": false}],
          ["time", {"reserved": false}],
          ["title", {"reserved": true}],
          ["tr", {"reserved": false}],
          ["track", {"reserved": true}],
          ["tt", {"reserved": false}],
          ["u", {"reserved": false}],
          ["ul", {"reserved": false}],
          ["var", {"reserved": false}],
          ["video", {"reserved": false}],
          ["wbr", {"reserved": false}],
          ["xmp", {"reserved": false}],
        ]
      )
    );
    expect(context).toEqual(
      expect.arrayContaining(
        [
          ["a", {"reserved": false}],
          ["abbr", {"reserved": false}],
          ["acronym", {"reserved": false}],
          ["address", {"reserved": false}],
          ["applet", {"reserved": false}],
          ["area", {"reserved": false}],
          ["article", {"reserved": false}],
          ["aside", {"reserved": false}],
          ["audio", {"reserved": false}],
          ["b", {"reserved": false}],
          ["base", {"reserved": true}],
          ["bdi", {"reserved": false}],
          ["bdo", {"reserved": false}],
          ["big", {"reserved": false}],
          ["blink", {"reserved": false}],
          ["blockquote", {"reserved": false}],
          ["body", {"reserved": false}],
          ["br", {"reserved": false}],
          ["button", {"reserved": false}],
          ["canvas", {"reserved": false}],
          ["caption", {"reserved": false}],
          ["center", {"reserved": false}],
          ["cite", {"reserved": false}],
          ["code", {"reserved": false}],
          ["col", {"reserved": true}],
          ["colgroup", {"reserved": true}],
          ["content", {"reserved": false}],
          ["data", {"reserved": false}],
          ["datalist", {"reserved": false}],
          ["dd", {"reserved": false}],
          ["del", {"reserved": false}],
          ["details", {"reserved": false}],
          ["dfn", {"reserved": false}],
          ["dialog", {"reserved": false}],
          ["dir", {"reserved": false}],
          ["div", {"reserved": false}],
          ["dl", {"reserved": false}],
          ["dt", {"reserved": false}],
          ["em", {"reserved": false}],
          ["embed", {"reserved": false}],
          ["fieldset", {"reserved": false}],
          ["figcaption", {"reserved": false}],
          ["figure", {"reserved": false}],
          ["font", {"reserved": false}],
          ["footer", {"reserved": false}],
          ["form", {"reserved": false}],
          ["frame", {"reserved": false}],
          ["frameset", {"reserved": false}],
          ["h1", {"reserved": false}],
          ["h2", {"reserved": false}],
          ["h3", {"reserved": false}],
          ["h4", {"reserved": false}],
          ["h5", {"reserved": false}],
          ["h6", {"reserved": false}],
          ["head", {"reserved": true}],
          ["header", {"reserved": false}],
          ["hgroup", {"reserved": false}],
          ["hr", {"reserved": false}],
          ["html", {"reserved": true}],
          ["i", {"reserved": false}],
          ["iframe", {"reserved": false}],
          ["img", {"reserved": false}],
          ["input", {"reserved": false}],
          ["ins", {"reserved": false}],
          ["kbd", {"reserved": false}],
          ["keygen", {"reserved": false}],
          ["label", {"reserved": false}],
          ["legend", {"reserved": false}],
          ["li", {"reserved": false}],
          ["link", {"reserved": true}],
          ["main", {"reserved": false}],
          ["map", {"reserved": false}],
          ["mark", {"reserved": false}],
          ["marquee", {"reserved": false}],
          ["menu", {"reserved": false}],
          ["menuitem", {"reserved": false}],
          ["meta", {"reserved": true}],
          ["meter", {"reserved": false}],
          ["nav", {"reserved": false}],
          ["noembed", {"reserved": true}],
          ["noscript", {"reserved": true}],
          ["object", {"reserved": false}],
          ["ol", {"reserved": false}],
          ["optgroup", {"reserved": false}],
          ["option", {"reserved": false}],
          ["output", {"reserved": false}],
          ["p", {"reserved": false}],
          ["param", {"reserved": true}],
          ["picture", {"reserved": true}],
          ["pre", {"reserved": false}],
          ["progress", {"reserved": false}],
          ["q", {"reserved": false}],
          ["rp", {"reserved": false}],
          ["rt", {"reserved": false}],
          ["rtc", {"reserved": false}],
          ["ruby", {"reserved": false}],
          ["s", {"reserved": false}],
          ["samp", {"reserved": false}],
          ["script", {"reserved": true}],
          ["section", {"reserved": false}],
          ["select", {"reserved": false}],
          ["small", {"reserved": false}],
          ["source", {"reserved": true}],
          ["spacer", {"reserved": false}],
          ["span", {"reserved": false}],
          ["strike", {"reserved": false}],
          ["strong", {"reserved": false}],
          ["style", {"reserved": true}],
          ["sub", {"reserved": false}],
          ["summary", {"reserved": false}],
          ["sup", {"reserved": false}],
          ["table", {"reserved": false}],
          ["tbody", {"reserved": false}],
          ["td", {"reserved": false}],
          ["textarea", {"reserved": false}],
          ["tfoot", {"reserved": false}],
          ["th", {"reserved": false}],
          ["thead", {"reserved": false}],
          ["time", {"reserved": false}],
          ["title", {"reserved": true}],
          ["tr", {"reserved": false}],
          ["track", {"reserved": true}],
          ["tt", {"reserved": false}],
          ["u", {"reserved": false}],
          ["ul", {"reserved": false}],
          ["var", {"reserved": false}],
          ["video", {"reserved": false}],
          ["wbr", {"reserved": false}],
          ["xmp", {"reserved": false}],
        ]
      )
    );
  });
  it('get', function () {
    expect(domMap.get('a')).toBeDefined();
    expect(domMap.get('fake element')).toBeUndefined();
  });
  it('has', function () {
    expect(domMap.has('a')).toEqual(true);
    expect(domMap.has('fake element')).toEqual(false);
  });
  it('keys', function () {
    expect(domMap.keys()).toEqual(
      expect.arrayContaining(
        [
          "a",
          "abbr",
          "acronym",
          "address",
          "applet",
          "area",
          "article",
          "aside",
          "audio",
          "b",
          "base",
          "bdi",
          "bdo",
          "big",
          "blink",
          "blockquote",
          "body",
          "br",
          "button",
          "canvas",
          "caption",
          "center",
          "cite",
          "code",
          "col",
          "colgroup",
          "content",
          "data",
          "datalist",
          "dd",
          "del",
          "details",
          "dfn",
          "dialog",
          "dir",
          "div",
          "dl",
          "dt",
          "em",
          "embed",
          "fieldset",
          "figcaption",
          "figure",
          "font",
          "footer",
          "form",
          "frame",
          "frameset",
          "h1",
          "h2",
          "h3",
          "h4",
          "h5",
          "h6",
          "head",
          "header",
          "hgroup",
          "hr",
          "html",
          "i",
          "iframe",
          "img",
          "input",
          "ins",
          "kbd",
          "keygen",
          "label",
          "legend",
          "li",
          "link",
          "main",
          "map",
          "mark",
          "marquee",
          "menu",
          "menuitem",
          "meta",
          "meter",
          "nav",
          "noembed",
          "noscript",
          "object",
          "ol",
          "optgroup",
          "option",
          "output",
          "p",
          "param",
          "picture",
          "pre",
          "progress",
          "q",
          "rp",
          "rt",
          "rtc",
          "ruby",
          "s",
          "samp",
          "script",
          "section",
          "select",
          "small",
          "source",
          "spacer",
          "span",
          "strike",
          "strong",
          "style",
          "sub",
          "summary",
          "sup",
          "table",
          "tbody",
          "td",
          "textarea",
          "tfoot",
          "th",
          "thead",
          "time",
          "title",
          "tr",
          "track",
          "tt",
          "u",
          "ul",
          "var",
          "video",
          "wbr",
          "xmp",
        ],
      ),
    );
    expect([...domMap.keys()]).toEqual(
      expect.arrayContaining(
        [
          "a",
          "abbr",
          "acronym",
          "address",
          "applet",
          "area",
          "article",
          "aside",
          "audio",
          "b",
          "base",
          "bdi",
          "bdo",
          "big",
          "blink",
          "blockquote",
          "body",
          "br",
          "button",
          "canvas",
          "caption",
          "center",
          "cite",
          "code",
          "col",
          "colgroup",
          "content",
          "data",
          "datalist",
          "dd",
          "del",
          "details",
          "dfn",
          "dialog",
          "dir",
          "div",
          "dl",
          "dt",
          "em",
          "embed",
          "fieldset",
          "figcaption",
          "figure",
          "font",
          "footer",
          "form",
          "frame",
          "frameset",
          "h1",
          "h2",
          "h3",
          "h4",
          "h5",
          "h6",
          "head",
          "header",
          "hgroup",
          "hr",
          "html",
          "i",
          "iframe",
          "img",
          "input",
          "ins",
          "kbd",
          "keygen",
          "label",
          "legend",
          "li",
          "link",
          "main",
          "map",
          "mark",
          "marquee",
          "menu",
          "menuitem",
          "meta",
          "meter",
          "nav",
          "noembed",
          "noscript",
          "object",
          "ol",
          "optgroup",
          "option",
          "output",
          "p",
          "param",
          "picture",
          "pre",
          "progress",
          "q",
          "rp",
          "rt",
          "rtc",
          "ruby",
          "s",
          "samp",
          "script",
          "section",
          "select",
          "small",
          "source",
          "spacer",
          "span",
          "strike",
          "strong",
          "style",
          "sub",
          "summary",
          "sup",
          "table",
          "tbody",
          "td",
          "textarea",
          "tfoot",
          "th",
          "thead",
          "time",
          "title",
          "tr",
          "track",
          "tt",
          "u",
          "ul",
          "var",
          "video",
          "wbr",
          "xmp",
        ],
      ),
    );
  });
  it('values', function () {
    expect(domMap.values()).toEqual(
      expect.arrayContaining(
        [
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
        ],
      ),
    );
    expect([...domMap.values()]).toEqual(
      expect.arrayContaining(
        [
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": true},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
          {"reserved": false},
        ],
      ),
    );
  });
});

describe('domMap', function () {
  describe('iteration', function () {
    it('should have an iterator defined', function () {
      expect(domMap[Symbol.iterator]).not.toBeUndefined();
    });
    it('should support the spread operator', function () {
      expect([...domMap].length).toEqual(129);
      expect([...domMap]).toEqual(
        expect.arrayContaining(
          [
            ["a", {"reserved": false}],
            ["abbr", {"reserved": false}],
            ["acronym", {"reserved": false}],
            ["address", {"reserved": false}],
            ["applet", {"reserved": false}],
            ["area", {"reserved": false}],
            ["article", {"reserved": false}],
            ["aside", {"reserved": false}],
            ["audio", {"reserved": false}],
            ["b", {"reserved": false}],
            ["base", {"reserved": true}],
            ["bdi", {"reserved": false}],
            ["bdo", {"reserved": false}],
            ["big", {"reserved": false}],
            ["blink", {"reserved": false}],
            ["blockquote", {"reserved": false}],
            ["body", {"reserved": false}],
            ["br", {"reserved": false}],
            ["button", {"reserved": false}],
            ["canvas", {"reserved": false}],
            ["caption", {"reserved": false}],
            ["center", {"reserved": false}],
            ["cite", {"reserved": false}],
            ["code", {"reserved": false}],
            ["col", {"reserved": true}],
            ["colgroup", {"reserved": true}],
            ["content", {"reserved": false}],
            ["data", {"reserved": false}],
            ["datalist", {"reserved": false}],
            ["dd", {"reserved": false}],
            ["del", {"reserved": false}],
            ["details", {"reserved": false}],
            ["dfn", {"reserved": false}],
            ["dialog", {"reserved": false}],
            ["dir", {"reserved": false}],
            ["div", {"reserved": false}],
            ["dl", {"reserved": false}],
            ["dt", {"reserved": false}],
            ["em", {"reserved": false}],
            ["embed", {"reserved": false}],
            ["fieldset", {"reserved": false}],
            ["figcaption", {"reserved": false}],
            ["figure", {"reserved": false}],
            ["font", {"reserved": false}],
            ["footer", {"reserved": false}],
            ["form", {"reserved": false}],
            ["frame", {"reserved": false}],
            ["frameset", {"reserved": false}],
            ["h1", {"reserved": false}],
            ["h2", {"reserved": false}],
            ["h3", {"reserved": false}],
            ["h4", {"reserved": false}],
            ["h5", {"reserved": false}],
            ["h6", {"reserved": false}],
            ["head", {"reserved": true}],
            ["header", {"reserved": false}],
            ["hgroup", {"reserved": false}],
            ["hr", {"reserved": false}],
            ["html", {"reserved": true}],
            ["i", {"reserved": false}],
            ["iframe", {"reserved": false}],
            ["img", {"reserved": false}],
            ["input", {"reserved": false}],
            ["ins", {"reserved": false}],
            ["kbd", {"reserved": false}],
            ["keygen", {"reserved": false}],
            ["label", {"reserved": false}],
            ["legend", {"reserved": false}],
            ["li", {"reserved": false}],
            ["link", {"reserved": true}],
            ["main", {"reserved": false}],
            ["map", {"reserved": false}],
            ["mark", {"reserved": false}],
            ["marquee", {"reserved": false}],
            ["menu", {"reserved": false}],
            ["menuitem", {"reserved": false}],
            ["meta", {"reserved": true}],
            ["meter", {"reserved": false}],
            ["nav", {"reserved": false}],
            ["noembed", {"reserved": true}],
            ["noscript", {"reserved": true}],
            ["object", {"reserved": false}],
            ["ol", {"reserved": false}],
            ["optgroup", {"reserved": false}],
            ["option", {"reserved": false}],
            ["output", {"reserved": false}],
            ["p", {"reserved": false}],
            ["param", {"reserved": true}],
            ["picture", {"reserved": true}],
            ["pre", {"reserved": false}],
            ["progress", {"reserved": false}],
            ["q", {"reserved": false}],
            ["rp", {"reserved": false}],
            ["rt", {"reserved": false}],
            ["rtc", {"reserved": false}],
            ["ruby", {"reserved": false}],
            ["s", {"reserved": false}],
            ["samp", {"reserved": false}],
            ["script", {"reserved": true}],
            ["section", {"reserved": false}],
            ["select", {"reserved": false}],
            ["small", {"reserved": false}],
            ["source", {"reserved": true}],
            ["spacer", {"reserved": false}],
            ["span", {"reserved": false}],
            ["strike", {"reserved": false}],
            ["strong", {"reserved": false}],
            ["style", {"reserved": true}],
            ["sub", {"reserved": false}],
            ["summary", {"reserved": false}],
            ["sup", {"reserved": false}],
            ["table", {"reserved": false}],
            ["tbody", {"reserved": false}],
            ["td", {"reserved": false}],
            ["textarea", {"reserved": false}],
            ["tfoot", {"reserved": false}],
            ["th", {"reserved": false}],
            ["thead", {"reserved": false}],
            ["time", {"reserved": false}],
            ["title", {"reserved": true}],
            ["tr", {"reserved": false}],
            ["track", {"reserved": true}],
            ["tt", {"reserved": false}],
            ["u", {"reserved": false}],
            ["ul", {"reserved": false}],
            ["var", {"reserved": false}],
            ["video", {"reserved": false}],
            ["wbr", {"reserved": false}],
            ["xmp", {"reserved": false}],
          ]
        )
      );
    });
    it('should support the for..of pattern', function () {
      const output = [];
      for (const [key, value] of domMap) {
        output.push([key, value]);
      }
      expect(output).toEqual(
        expect.arrayContaining(
          [
            ["a", {"reserved": false}],
            ["abbr", {"reserved": false}],
            ["acronym", {"reserved": false}],
            ["address", {"reserved": false}],
            ["applet", {"reserved": false}],
            ["area", {"reserved": false}],
            ["article", {"reserved": false}],
            ["aside", {"reserved": false}],
            ["audio", {"reserved": false}],
            ["b", {"reserved": false}],
            ["base", {"reserved": true}],
            ["bdi", {"reserved": false}],
            ["bdo", {"reserved": false}],
            ["big", {"reserved": false}],
            ["blink", {"reserved": false}],
            ["blockquote", {"reserved": false}],
            ["body", {"reserved": false}],
            ["br", {"reserved": false}],
            ["button", {"reserved": false}],
            ["canvas", {"reserved": false}],
            ["caption", {"reserved": false}],
            ["center", {"reserved": false}],
            ["cite", {"reserved": false}],
            ["code", {"reserved": false}],
            ["col", {"reserved": true}],
            ["colgroup", {"reserved": true}],
            ["content", {"reserved": false}],
            ["data", {"reserved": false}],
            ["datalist", {"reserved": false}],
            ["dd", {"reserved": false}],
            ["del", {"reserved": false}],
            ["details", {"reserved": false}],
            ["dfn", {"reserved": false}],
            ["dialog", {"reserved": false}],
            ["dir", {"reserved": false}],
            ["div", {"reserved": false}],
            ["dl", {"reserved": false}],
            ["dt", {"reserved": false}],
            ["em", {"reserved": false}],
            ["embed", {"reserved": false}],
            ["fieldset", {"reserved": false}],
            ["figcaption", {"reserved": false}],
            ["figure", {"reserved": false}],
            ["font", {"reserved": false}],
            ["footer", {"reserved": false}],
            ["form", {"reserved": false}],
            ["frame", {"reserved": false}],
            ["frameset", {"reserved": false}],
            ["h1", {"reserved": false}],
            ["h2", {"reserved": false}],
            ["h3", {"reserved": false}],
            ["h4", {"reserved": false}],
            ["h5", {"reserved": false}],
            ["h6", {"reserved": false}],
            ["head", {"reserved": true}],
            ["header", {"reserved": false}],
            ["hgroup", {"reserved": false}],
            ["hr", {"reserved": false}],
            ["html", {"reserved": true}],
            ["i", {"reserved": false}],
            ["iframe", {"reserved": false}],
            ["img", {"reserved": false}],
            ["input", {"reserved": false}],
            ["ins", {"reserved": false}],
            ["kbd", {"reserved": false}],
            ["keygen", {"reserved": false}],
            ["label", {"reserved": false}],
            ["legend", {"reserved": false}],
            ["li", {"reserved": false}],
            ["link", {"reserved": true}],
            ["main", {"reserved": false}],
            ["map", {"reserved": false}],
            ["mark", {"reserved": false}],
            ["marquee", {"reserved": false}],
            ["menu", {"reserved": false}],
            ["menuitem", {"reserved": false}],
            ["meta", {"reserved": true}],
            ["meter", {"reserved": false}],
            ["nav", {"reserved": false}],
            ["noembed", {"reserved": true}],
            ["noscript", {"reserved": true}],
            ["object", {"reserved": false}],
            ["ol", {"reserved": false}],
            ["optgroup", {"reserved": false}],
            ["option", {"reserved": false}],
            ["output", {"reserved": false}],
            ["p", {"reserved": false}],
            ["param", {"reserved": true}],
            ["picture", {"reserved": true}],
            ["pre", {"reserved": false}],
            ["progress", {"reserved": false}],
            ["q", {"reserved": false}],
            ["rp", {"reserved": false}],
            ["rt", {"reserved": false}],
            ["rtc", {"reserved": false}],
            ["ruby", {"reserved": false}],
            ["s", {"reserved": false}],
            ["samp", {"reserved": false}],
            ["script", {"reserved": true}],
            ["section", {"reserved": false}],
            ["select", {"reserved": false}],
            ["small", {"reserved": false}],
            ["source", {"reserved": true}],
            ["spacer", {"reserved": false}],
            ["span", {"reserved": false}],
            ["strike", {"reserved": false}],
            ["strong", {"reserved": false}],
            ["style", {"reserved": true}],
            ["sub", {"reserved": false}],
            ["summary", {"reserved": false}],
            ["sup", {"reserved": false}],
            ["table", {"reserved": false}],
            ["tbody", {"reserved": false}],
            ["td", {"reserved": false}],
            ["textarea", {"reserved": false}],
            ["tfoot", {"reserved": false}],
            ["th", {"reserved": false}],
            ["thead", {"reserved": false}],
            ["time", {"reserved": false}],
            ["title", {"reserved": true}],
            ["tr", {"reserved": false}],
            ["track", {"reserved": true}],
            ["tt", {"reserved": false}],
            ["u", {"reserved": false}],
            ["ul", {"reserved": false}],
            ["var", {"reserved": false}],
            ["video", {"reserved": false}],
            ["wbr", {"reserved": false}],
            ["xmp", {"reserved": false}],
          ]
        )
      );
    });
  });
});
